#include <windows.h>
#include <stdio.h>
#include "win055.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void AsignarTexto(HWND, char*);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */

    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "Menu";
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground = GetSysColorBrush(COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 055",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           544,                 /* Ancho */
           375,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
    }

    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static HINSTANCE hInstance;
    static HWND hctrl;
    static HFONT hfont;
    RECT re;
    int indice, indicecaracter;
    char mensaje[512];
    LRESULT punto;

    switch (msg)                  /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           /* Insertar control Edit */
           GetClientRect(hwnd, &re);
           hctrl = CreateWindowEx(
              0,
              "EDIT",          /* Nombre de la clase */
              "",              /* Texto del ttulo, no tiene */
              ES_LEFT | ES_MULTILINE | ES_WANTRETURN |
              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP |
              WS_HSCROLL | WS_VSCROLL, /* Estilo */
              0, 0,            /* Posicin */
              re.right, re.bottom, /* Tamao */
              hwnd,            /* Ventana padre */
              (HMENU)ID_TEXTO, /* Identificador del control */
              hInstance,       /* Instancia */
              NULL);           /* Sin datos de creacin de ventana */
           hfont = CreateFont(24, 0, 0, 0, 300,
              FALSE, FALSE, FALSE, DEFAULT_CHARSET,
              OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
              PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN,
              "Times New Roman");
           //hfont = (HFONT)GetStockObject( DEFAULT_GUI_FONT );
           SendMessage(hctrl, WM_SETFONT, (WPARAM)hfont, MAKELPARAM(TRUE, 0));
           /* Inicializacin de los datos de la aplicacin */
           AsignarTexto(hctrl, "texto.txt");
           SetFocus(hctrl);
           return 0;
        case WM_COMMAND:
           switch(LOWORD(wParam)) {
              case CM_SALIR:
                 DestroyWindow(hwnd);
                 break;
              case CM_CARACTER:
                 indice = SendMessage(hctrl, EM_CHARFROMPOS, 0, MAKELPARAM(86,52));
                 /*sprintf(mensaje, "ndice de carcter en (%d, %d): "
                   "Lnea %d, carcter %d",
                    86, 52, HIWORD(indice), LOWORD(indice));
                 MessageBox(hwnd, mensaje, "Ejemplo 55", MB_OK); */
                 indicecaracter = LOWORD(indice);
                 /* Seleccionar carcter en esa coordenada */
                 SendMessage(hctrl, EM_SETSEL, indicecaracter,
                    indicecaracter+1);
                 break;
              case CM_COORDENADA:
                 punto = SendMessage(hctrl, EM_POSFROMCHAR, 153, 0);
                 sprintf(mensaje, "Coordenadas del carcter 153: "
                   "(%d, %d)", LOWORD(punto), HIWORD(punto));
                 MessageBox(hwnd, mensaje, "Ejemplo 55", MB_OK);
                 break;
           }
           break;
        case WM_SIZE:
           GetClientRect(hwnd, &re);
           MoveWindow(hctrl, 0, 0, re.right, re.bottom, TRUE);
           break;
        case WM_DESTROY:
           DeleteObject(hfont);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

void AsignarTexto(HWND hctrl, char* fichero) {
   FILE *fe;
   char cad[1024];
   char* buffer;
   int l;
   int i;
   char separador[4] = {'\r', '\r', '\n', 0};
   HLOCAL hloc;

   fe = fopen(fichero, "r");
   /* Calcular el tamao del buffer:
      eliminar los caracteres de control al final de cada
      lnea y sumar tres (ruptura de lnea blanda \r\r\n) */
   l = 0;
   do {
      fgets(cad, 1024, fe);
      if(!feof(fe)) {
         /* No contar los caracteres especiales al final */
         i = strlen(cad)-1;
         while(i>=0 && cad[i] < ' ') i--;
         l += i + 4; /* Sumar tres caracteres por lnea.
            Sumamos el valor 4 porque i contiene la longitud de
            la cadena menos 1 */
      }
   } while (!feof(fe));

   hloc = (HLOCAL)SendMessage(hctrl, EM_GETHANDLE, 0, 0);
   LocalFree(hloc);
   hloc = LocalAlloc(LMEM_MOVEABLE, l+1);

   buffer = (char *)LocalLock(hloc);

   /* Crear buffer */
   //buffer = (char *)malloc(l+1);
   buffer[0] = 0;

   /* Hacer la lectura */
   rewind(fe);
   do {
      fgets(cad, 1024, fe);
      if(!feof(fe)) {
         /* Eliminar los caracteres especiales al final */
         i = strlen(cad)-1;
         while(i>=0 && cad[i] < ' ') cad[i--] = 0;
         strcat(buffer, cad);
         strcat(buffer, separador);
      }
   } while (!feof(fe));

   fclose(fe);
   LocalUnlock(hloc);
   SendMessage(hctrl, EM_SETHANDLE, (WPARAM)hloc, 0);
   // SendMessage(hctrl, WM_SETTEXT, 0, (LPARAM)buffer);
   // free(buffer);
}
